﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private xui As XUI
	
'	Machine configuration
	Private rightRotor As Rotor
	Private centerRotor As Rotor
	Private leftRotor As Rotor
	Private reflector1 As Reflector
	Private plugboard(26) As Int
	
End Sub

'Initializes the object. 
Public Sub Initialize(left() As String, center() As String, right() As String, ref As String) As Enigma
		
'		Check for correct rotor
	If(Not(correctRotor(left)) Or Not(correctRotor(center)) Or Not(correctRotor(right))) Then 
		Log("Please choose a correct Rotor")
	End If	
'		Check for correct reflector
	If(Not(correctReflector(ref))) Then 
		Log("Please choose a correct Reflector")
	End If
		
'		Assign rotors and reflector
	leftRotor.Initialize(left(0), left(1).charAt(0))
	centerRotor.Initialize(center(0), center(1).charAt(0))
	rightRotor.Initialize(right(0), right(1).charAt(0))
	Dim rf As Reflector
	rf.Initialize(ref)
	reflector1 = rf

	resetPlugboard
	
	Return Me
	
End Sub

'check if the selected rotor is a valid rotor
Private Sub correctRotor(rotor1() As String) As Boolean

	Return (rotor1(0) = Constants.ROTOR_I(0)) Or (rotor1(0) = Constants.ROTOR_II(0)) Or (rotor1(0) = Constants.ROTOR_III(0)) Or (rotor1(0) = Constants.ROTOR_IV(0)) Or (rotor1(0) = Constants.ROTOR_V(0))
End Sub

'check if the selected reflector is a valid reflector
Private Sub correctReflector(reflector2 As String) As Boolean
	Return (reflector2 = Constants.REFLECTOR_A) Or  (reflector2 = Constants.REFLECTOR_B) Or (reflector2 = Constants.REFLECTOR_C)
End Sub

'reset the plug board
Public Sub resetPlugboard()
	For wire = 0 To 25
		plugboard(wire) = -1
	Next
End Sub

'set the text to encrypt
Public Sub typetext(txt As String) As String
	'Log("input = " & txt)
	Dim  output As String = ""
	For j = 0 To txt.Length - 1
		
		'Allow upper Case letter
		If (Asc(txt.charAt(j)) >= Asc("A") And Asc(txt.charAt(j)) <= Asc("Z")) Then
			output = output & rotorsEncryption(txt.charAt(j))
			'Log("HERE  = " & txt.charAt(j))
			
		'Allow white space And new line
		else if (txt.charAt(j) = " " Or txt.charAt(j) = CRLF) Then
			output = output & txt.charAt(j)
			'Log("HERE 2")
		'If other characters
		Else
			Log("Only upper case letters allowed!")
		End If
	Next
	'Log("output = " & output)
	Return output
End Sub

'Rotor encryption
Private Sub rotorsEncryption(inputC As Char) As Char
	
	Log("Input Char = " & inputC)
	'Rotate Rotor left & center
	If (centerRotor.getNotch() = centerRotor.getRotorHead()) Then
		'Log("IC1")
		leftRotor.rotate()
		'LogColor(leftRotor.getRotorHead, xui.Color_Red)
		Main.Label68.Text = leftRotor.getRotorHead
		'Main.cmbRotLeftStart.Value = leftRotor.getRotorHead
		
		centerRotor.rotate()
		'LogColor(centerRotor.getRotorHead, xui.Color_Green)
		Main.Label69.Text = centerRotor.getRotorHead
		'Main.cmbRotCenterStart.Value = centerRotor.getRotorHead
	End If

	'Rotate Rotor center
	If (rightRotor.getNotch() = rightRotor.getRotorHead()) Then
		centerRotor.rotate()
		'LogColor(centerRotor.getRotorHead, xui.Color_Green)
		Main.Label69.Text = centerRotor.getRotorHead
		'Main.cmbRotCenterStart.Value = centerRotor.getRotorHead
		
		'Log("IC2")
	End If	

	'Rotate Rotor right
	rightRotor.rotate()
	'LogColor(rightRotor.getRotorHead, xui.Color_Blue)
	'Main.cmbRotRightStart.Value = rightRotor.getRotorHead
	Main.Label70.Text = rightRotor.getRotorHead
	
	
	'Static wheel
	Dim input As Int = Asc(inputC) - Asc("A")
	'Log("input = " & Chr(input+65))
	'Pass by the plugboard
	If(plugboard(input) <> -1) Then
		input = plugboard(input)
		'Log("plug in = "& Chr(input + 65))
		'Log("input plugboard = " & input)
	End If	

'	Dim inOfrightRotor As Int = rightRotor.getInputOf(input)
'	Log("inOfRightRotor = " & Chr(inOfrightRotor + 65))
	
	
	'Start processing from the right wheel To left wheel
	Dim outOfrightRotor As Int = rightRotor.getOutputOf(input)
	'Log("outOfRightRotor = " & Chr(outOfrightRotor + 65))
	'Log("outOfrightRotor = " & outOfrightRotor)

'	Dim inOfcenterRotor As Int = centerRotor.getInputOf(outOfrightRotor)
'	Log("inOfCenterRotor = " & Chr(outOfrightRotor + 65))
	
	
	Dim outOfcenterRotor As Int = centerRotor.getOutputOf(outOfrightRotor)
	'Log("outOfCenterRotor = " & Chr(outOfcenterRotor + 65))
	'Log("outOfcenterRotor = " & outOfcenterRotor)
	Dim outOfleftRotor As Int = leftRotor.getOutputOf(outOfcenterRotor)
	'Log("outOfleftRotor = " & Chr(outOfleftRotor + 65))
	'Log("outOfleftRotor = " & outOfleftRotor)

	'Enter And Exit the reflector
	Dim outOfReflector As Int = reflector1.getOutputOf(outOfleftRotor)
	'Log("outOfReflector = " & Chr(outOfReflector + 65))
	'Log("outOfReflector = " & outOfReflector)

	'Start processing from left wheel To right wheel
	Dim inOfleftRotor As Int = leftRotor.getInputOf(outOfReflector)
	'Log("inOfLeftRotor = " & Chr(inOfleftRotor + 65))
	'Log("inOfleftRotor = " & inOfleftRotor)
	Dim inOfcenterRotor As Int = centerRotor.getInputOf(inOfleftRotor)
	'Log("inOfCenterRotor = " & Chr(inOfcenterRotor + 65))
	'Log("inOfcenterRotor = " & inOfcenterRotor)
	Dim inOfrightRotor As Int = rightRotor.getInputOf(inOfcenterRotor)
	'Log("inOfRghtRotor = " & Chr(inOfrightRotor + 65))
	'Log("inOfrightRotor = " & inOfrightRotor)
	
	'Pass by the plugboard
	If(plugboard(inOfrightRotor) <> -1) Then
		inOfrightRotor = plugboard(inOfrightRotor)
		'Log("plugout = " & Chr(inOfrightRotor + 65))

	End If
	'Static wheel
	Log("Encoded Char = " & Chr(inOfrightRotor + (Asc("A"))))
	Return Chr(inOfrightRotor + (Asc("A")))
	
End Sub

'Get left rotor
Public Sub getLeftRotor() As Rotor
	Return leftRotor
End Sub

'Get center rotor
Public Sub getCenterRotor() As Rotor
	Return centerRotor
End Sub

'Get right rotor
Public Sub getRightRotor() As Rotor
	Return rightRotor
End Sub

'Get reflector
Public Sub getReflector() As Reflector
	Return reflector1
End Sub

'Set the plug boad
Public Sub insertPlugboardWire(a1 As Char, b1 As Char)
	plugboard(Asc(a1) - Asc("A")) = Asc(b1) - Asc("A")
	plugboard(Asc(b1) - Asc("A")) = Asc(a1) - Asc("A")
End Sub

'Unset a wire from the plug boad
Public Sub removePlugboardWire(a1 As Char)
	plugboard(plugboard(Asc(a1) - Asc("A"))) = -1
	plugboard(Asc(a1) - Asc("A")) = -1
End Sub

'Get the linked char to "A"
Public Sub getPlugboardOf(a1 As Int) As Int
	Return plugboard(a1)
End Sub

'Checks if a letter is occupied
Public Sub isPlugged(c1 As Char) As Boolean
	Return plugboard(Asc(c1) - Asc("A")) <> -1
End Sub

'Reset machine
Public Sub resetRotation()
	leftRotor.reset()
	centerRotor.reset()
	rightRotor.reset()
End Sub

