﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	
	Private	rotorOut(26) As Int
	Private rotorIn(26) As Int
	Private rotorHead As Int
	Private ringHead As Int
	Private notch1 As Char
	Private rotate1 As Int
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (rotor1 As String, notch As Char) As Rotor
		notch1 = notch
		Dim aa() As String = Array As String(rotor1, notch1 & "")
		setRotor(aa)
		Return Me
End Sub


Public Sub setRotor(rotor1() As String)
	notch1 = rotor1(1).charAt(0)
	For i = 0 To 25
		Dim fromm As Int = Asc("A") - 65 + i
		Dim too As Int = Asc(rotor1(0).charAt(i)) - 65
		If fromm < too Then
			rotorOut(i) = too - fromm
		Else
			rotorOut(i) = (26 - (fromm - too)) Mod 26
		End If
		rotorIn( (i + rotorOut(i)) Mod 26) = rotorOut(i)
	Next
End Sub


public Sub	getOutputOf(pos As Int) As Int
	Dim rotorRingDiff As Int
	If rotorHead >= ringHead Then
		rotorRingDiff = rotorHead - ringHead
	Else
		rotorRingDiff = 26 - ringHead + rotorHead
	End If

	Return (pos + rotorOut( (pos + rotate1 + rotorRingDiff) Mod 26)) Mod 26      'pos + Jump To mirror with the Next rotor
End Sub


Public Sub getInputOf(pos As Int) As Int
	Dim rotorRingDiff As Int
	If rotorHead >= ringHead Then
		rotorRingDiff = rotorHead - ringHead 
	Else
		rotorRingDiff = 26 - ringHead + rotorHead
	End If
	Dim posJump As Int = pos - rotorIn( (pos + rotate1 + rotorRingDiff) Mod 26)
	If posJump > 0 Then
		Return (posJump Mod 26)
	Else
		Return ( 26 + posJump) Mod 26
	End If

End Sub

Public Sub getNotch() As Char
	Return notch1
End Sub

Public Sub getRotorHead() As Char
	'Log(Chr(((Asc("A") - 65 + (rotorHead + rotate1)) Mod 26)+65))
	Return Chr(((Asc("A") - 65 + (rotorHead + rotate1)) Mod 26)+65)
End Sub

Public Sub getRingHead() As Char
	Return Chr((Asc(("A")-65 + (ringHead + rotate1)) Mod 26)+65)
End Sub


public Sub rotate()
	rotate1 = (rotate1 + 1) Mod 26
End Sub


Public Sub setRotorHead(c As Char)
	If(Asc(c) < Asc("A") Or Asc(c) > Asc("Z")) Then
		Log("Only upper case letters allowed!")
	End If	
	rotorHead = Asc(c) - Asc("A")
	rotate1 = 0
End Sub

Public Sub setRingHead(c As Char)
	
	If(Asc(c) < Asc("A") Or Asc(c) > Asc("Z")) Then
		Log("Only upper case letters allowed!")
	End If	
	ringHead = Asc(c) - Asc("A")
End Sub


Public Sub getAnOutWire(pos As Int) As Int
	Return getOutputOf(pos)
End Sub

Public Sub getAnInWire(pos As Int) As Int
	Return getInputOf(pos)
End Sub

Public Sub reset(){
	rotate1 = 0
End Sub

